using System;
using System.Runtime.InteropServices;
using System.Reflection;
using System.Diagnostics;
using System.Windows.Forms;

namespace WToys
{
    [GuidAttribute("7E20BE57-79EC-431C-9856-99AE123C2BD3"), ProgId("WToys.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        private System.Windows.Forms.ImageList imageList1;

        private AddinExpress.MSO.ADXCommandBarButton btnAbout;
        private AddinExpress.MSO.ADXCommandBarComboBox cmbScale;
        private AddinExpress.MSO.ADXCommandBarComboBox cmbSpace;
        private AddinExpress.MSO.ADXCommandBarEdit edSpace;
        private AddinExpress.MSO.ADXCommandBarComboBox cmbPosition;
        private AddinExpress.MSO.ADXCommandBarEdit edPosition;
        private AddinExpress.MSO.ADXCommandBarComboBox cmbEffects;
        private AddinExpress.MSO.ADXCommandBar adxCommandBar1;
        private AddinExpress.MSO.ADXWordAppEvents adxWordEvents;
        internal ImageList ImageList2;
        internal AddinExpress.MSO.ADXRibbonTab WordRibbonTab;
        internal AddinExpress.MSO.ADXRibbonGroup AdxRibbonGroup1;
        internal AddinExpress.MSO.ADXRibbonButton RibbonButtonAbout;
        internal AddinExpress.MSO.ADXRibbonSeparator AdxRibbonSeparator1;
        internal AddinExpress.MSO.ADXRibbonBox RibbonBoxScale;
        internal AddinExpress.MSO.ADXRibbonComboBox RibbonComboBoxScale;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem1;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem2;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem3;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem4;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem5;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem6;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem7;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem8;
        internal AddinExpress.MSO.ADXRibbonBox RibbonBoxSpace;
        internal AddinExpress.MSO.ADXRibbonComboBox RibbonComboBoxSpace;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem9;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem10;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem11;
        internal AddinExpress.MSO.ADXRibbonEditBox RibbonEditBoxSpace;
        internal AddinExpress.MSO.ADXRibbonBox RibbonBoxPosition;
        internal AddinExpress.MSO.ADXRibbonComboBox RibbonComboBoxPosition;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem12;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem13;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem14;
        internal AddinExpress.MSO.ADXRibbonEditBox RibbonEditBoxPosition;
        internal AddinExpress.MSO.ADXRibbonSeparator AdxRibbonSeparator2;
        internal AddinExpress.MSO.ADXRibbonComboBox RibbonComboBoxEffects;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem15;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem16;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem17;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem18;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem19;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem20;
        internal AddinExpress.MSO.ADXRibbonItem AdxRibbonItem21;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components;

        #region Component Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddinModule));
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.adxCommandBar1 = new AddinExpress.MSO.ADXCommandBar(this.components);
            this.btnAbout = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.cmbScale = new AddinExpress.MSO.ADXCommandBarComboBox(this.components);
            this.cmbSpace = new AddinExpress.MSO.ADXCommandBarComboBox(this.components);
            this.edSpace = new AddinExpress.MSO.ADXCommandBarEdit(this.components);
            this.cmbPosition = new AddinExpress.MSO.ADXCommandBarComboBox(this.components);
            this.edPosition = new AddinExpress.MSO.ADXCommandBarEdit(this.components);
            this.cmbEffects = new AddinExpress.MSO.ADXCommandBarComboBox(this.components);
            this.adxWordEvents = new AddinExpress.MSO.ADXWordAppEvents(this.components);
            this.ImageList2 = new System.Windows.Forms.ImageList(this.components);
            this.WordRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.AdxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.RibbonButtonAbout = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.AdxRibbonSeparator1 = new AddinExpress.MSO.ADXRibbonSeparator(this.components);
            this.RibbonBoxScale = new AddinExpress.MSO.ADXRibbonBox(this.components);
            this.RibbonComboBoxScale = new AddinExpress.MSO.ADXRibbonComboBox(this.components);
            this.AdxRibbonItem1 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem2 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem3 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem4 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem5 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem6 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem7 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem8 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.RibbonBoxSpace = new AddinExpress.MSO.ADXRibbonBox(this.components);
            this.RibbonComboBoxSpace = new AddinExpress.MSO.ADXRibbonComboBox(this.components);
            this.AdxRibbonItem9 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem10 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem11 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.RibbonEditBoxSpace = new AddinExpress.MSO.ADXRibbonEditBox(this.components);
            this.RibbonBoxPosition = new AddinExpress.MSO.ADXRibbonBox(this.components);
            this.RibbonComboBoxPosition = new AddinExpress.MSO.ADXRibbonComboBox(this.components);
            this.AdxRibbonItem12 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem13 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem14 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.RibbonEditBoxPosition = new AddinExpress.MSO.ADXRibbonEditBox(this.components);
            this.AdxRibbonSeparator2 = new AddinExpress.MSO.ADXRibbonSeparator(this.components);
            this.RibbonComboBoxEffects = new AddinExpress.MSO.ADXRibbonComboBox(this.components);
            this.AdxRibbonItem15 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem16 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem17 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem18 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem19 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem20 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            this.AdxRibbonItem21 = new AddinExpress.MSO.ADXRibbonItem(this.components);
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "");
            // 
            // adxCommandBar1
            // 
            this.adxCommandBar1.CommandBarName = "Add-in Express Toys for Word (C#)";
            this.adxCommandBar1.CommandBarTag = "9d5ea9d0-31e5-4412-bab8-9bff828ee884";
            this.adxCommandBar1.Controls.Add(this.btnAbout);
            this.adxCommandBar1.Controls.Add(this.cmbScale);
            this.adxCommandBar1.Controls.Add(this.cmbSpace);
            this.adxCommandBar1.Controls.Add(this.edSpace);
            this.adxCommandBar1.Controls.Add(this.cmbPosition);
            this.adxCommandBar1.Controls.Add(this.edPosition);
            this.adxCommandBar1.Controls.Add(this.cmbEffects);
            this.adxCommandBar1.UpdateCounter = 24;
            // 
            // btnAbout
            // 
            this.btnAbout.Before = 1;
            this.btnAbout.BeginGroup = true;
            this.btnAbout.Caption = "About ADX Toys for Word";
            this.btnAbout.ControlTag = "fd47d7bc-0800-4095-b99c-64e4cc59d86d";
            this.btnAbout.Image = 0;
            this.btnAbout.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.btnAbout.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonIcon;
            this.btnAbout.Tag = "20";
            this.btnAbout.UpdateCounter = 5;
            this.btnAbout.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.btnAbout_Click);
            // 
            // cmbScale
            // 
            this.cmbScale.BeginGroup = true;
            this.cmbScale.Caption = "Scale";
            this.cmbScale.ControlTag = "ef5e096e-08e6-4aea-95c6-6efbf80316d7";
            this.cmbScale.DescriptionText = "Text Scale";
            this.cmbScale.DropDownWidth = 90;
            this.cmbScale.Items.AddRange(new string[] {
            "200%",
            "150%",
            "100%",
            "90%",
            "80%",
            "66%",
            "50%",
            "33%"});
            this.cmbScale.ListIndex = 3;
            this.cmbScale.Style = AddinExpress.MSO.ADXMsoComboStyle.adxMsoComboLabel;
            this.cmbScale.Tag = "10";
            this.cmbScale.UpdateCounter = 18;
            this.cmbScale.Width = 90;
            this.cmbScale.Change += new AddinExpress.MSO.ADXChange_EventHandler(this.cmbScale_Change);
            // 
            // cmbSpace
            // 
            this.cmbSpace.BeginGroup = true;
            this.cmbSpace.Caption = "Space";
            this.cmbSpace.ControlTag = "04efeacb-00bd-45fa-88d3-a9604e608ee8";
            this.cmbSpace.DescriptionText = "Text Space";
            this.cmbSpace.DropDownWidth = 120;
            this.cmbSpace.Items.AddRange(new string[] {
            "Normal",
            "Expanded",
            "Condensed"});
            this.cmbSpace.Style = AddinExpress.MSO.ADXMsoComboStyle.adxMsoComboLabel;
            this.cmbSpace.Tag = "30";
            this.cmbSpace.UpdateCounter = 15;
            this.cmbSpace.Width = 120;
            this.cmbSpace.Change += new AddinExpress.MSO.ADXChange_EventHandler(this.cmbSpace_Change);
            // 
            // edSpace
            // 
            this.edSpace.Caption = "Custom space";
            this.edSpace.ControlTag = "38cf6fcf-4831-4131-889d-8b91b287b837";
            this.edSpace.Tag = "40";
            this.edSpace.UpdateCounter = 11;
            this.edSpace.Width = 50;
            this.edSpace.Change += new AddinExpress.MSO.ADXChange_EventHandler(this.edSpace_Change);
            // 
            // cmbPosition
            // 
            this.cmbPosition.BeginGroup = true;
            this.cmbPosition.Caption = "Position";
            this.cmbPosition.ControlTag = "5bbcba12-3c33-486f-8737-4b5ccbf53387";
            this.cmbPosition.DescriptionText = "Text Position";
            this.cmbPosition.DropDownWidth = 120;
            this.cmbPosition.Items.AddRange(new string[] {
            "Normal",
            "Raised",
            "Lowered"});
            this.cmbPosition.ListIndex = 1;
            this.cmbPosition.Style = AddinExpress.MSO.ADXMsoComboStyle.adxMsoComboLabel;
            this.cmbPosition.UpdateCounter = 14;
            this.cmbPosition.Width = 120;
            this.cmbPosition.Change += new AddinExpress.MSO.ADXChange_EventHandler(this.cmbPosition_Change);
            // 
            // edPosition
            // 
            this.edPosition.Caption = "Custom Position";
            this.edPosition.ControlTag = "b44654dc-ee13-4ac5-ae98-0d2f42ae0f24";
            this.edPosition.UpdateCounter = 8;
            this.edPosition.Width = 50;
            this.edPosition.Change += new AddinExpress.MSO.ADXChange_EventHandler(this.edPosition_Change);
            // 
            // cmbEffects
            // 
            this.cmbEffects.BeginGroup = true;
            this.cmbEffects.Caption = "Effects";
            this.cmbEffects.ControlTag = "8c799dfb-a9fa-4aab-83b2-5e4e6901cb47";
            this.cmbEffects.DescriptionText = "Text Effects";
            this.cmbEffects.DropDownWidth = 180;
            this.cmbEffects.Items.AddRange(new string[] {
            "(none)",
            "Blinking Background",
            "Las Vegas Lights",
            "Marching Black Ants",
            "Marching Red Ants",
            "Shimmer",
            "Sparkle Text"});
            this.cmbEffects.ListIndex = 1;
            this.cmbEffects.Style = AddinExpress.MSO.ADXMsoComboStyle.adxMsoComboLabel;
            this.cmbEffects.Tag = "20";
            this.cmbEffects.UpdateCounter = 21;
            this.cmbEffects.Width = 180;
            this.cmbEffects.Change += new AddinExpress.MSO.ADXChange_EventHandler(this.cmbEffects_Change);
            // 
            // adxWordEvents
            // 
            this.adxWordEvents.DocumentChange += new System.EventHandler(this.adxWordEvents_DocumentChange);
            this.adxWordEvents.WindowActivate += new AddinExpress.MSO.ADXHostWindow_EventHandler(this.adxWordEvents_WindowActivate);
            this.adxWordEvents.WindowSelectionChange += new AddinExpress.MSO.ADXHostActiveObject_EventHandler(this.adxWordEvents_WindowSelectionChange);
            // 
            // ImageList2
            // 
            this.ImageList2.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ImageList2.ImageStream")));
            this.ImageList2.TransparentColor = System.Drawing.Color.Transparent;
            this.ImageList2.Images.SetKeyName(0, "logo32.bmp");
            // 
            // WordRibbonTab
            // 
            this.WordRibbonTab.Caption = "Add-in Express Toys for Word (C#)";
            this.WordRibbonTab.Controls.Add(this.AdxRibbonGroup1);
            this.WordRibbonTab.Id = "adxRibbonTab_f17f21daa9864b42986e9330988e1994";
            this.WordRibbonTab.InsertBeforeIdMso = "TabHome";
            this.WordRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // AdxRibbonGroup1
            // 
            this.AdxRibbonGroup1.Caption = "Add-in Express Toys";
            this.AdxRibbonGroup1.Controls.Add(this.RibbonButtonAbout);
            this.AdxRibbonGroup1.Controls.Add(this.AdxRibbonSeparator1);
            this.AdxRibbonGroup1.Controls.Add(this.RibbonBoxScale);
            this.AdxRibbonGroup1.Controls.Add(this.RibbonBoxSpace);
            this.AdxRibbonGroup1.Controls.Add(this.RibbonBoxPosition);
            this.AdxRibbonGroup1.Controls.Add(this.AdxRibbonSeparator2);
            this.AdxRibbonGroup1.Controls.Add(this.RibbonComboBoxEffects);
            this.AdxRibbonGroup1.Id = "adxRibbonGroup_606a2059f86541e99789dc58de14ec3c";
            this.AdxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.AdxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // RibbonButtonAbout
            // 
            this.RibbonButtonAbout.Caption = "About";
            this.RibbonButtonAbout.Id = "adxRibbonButton_cef79cf394f1402f8efd73e31eb677b8";
            this.RibbonButtonAbout.Image = 0;
            this.RibbonButtonAbout.ImageList = this.ImageList2;
            this.RibbonButtonAbout.ImageTransparentColor = System.Drawing.Color.White;
            this.RibbonButtonAbout.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            this.RibbonButtonAbout.ShowCaption = false;
            this.RibbonButtonAbout.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.RibbonButtonAbout.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.RibbonButtonAbout_OnClick);
            // 
            // AdxRibbonSeparator1
            // 
            this.AdxRibbonSeparator1.Id = "adxRibbonSeparator_0c00c1bb767141f4a4eb660351317422";
            this.AdxRibbonSeparator1.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // RibbonBoxScale
            // 
            this.RibbonBoxScale.Controls.Add(this.RibbonComboBoxScale);
            this.RibbonBoxScale.Id = "adxRibbonBox_ab46d84e684548358344d26cbf2903e3";
            this.RibbonBoxScale.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // RibbonComboBoxScale
            // 
            this.RibbonComboBoxScale.Caption = "Scale";
            this.RibbonComboBoxScale.Id = "adxRibbonComboBox_ee593fd9c98a40479885841887df98a9";
            this.RibbonComboBoxScale.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonComboBoxScale.Items.Add(this.AdxRibbonItem1);
            this.RibbonComboBoxScale.Items.Add(this.AdxRibbonItem2);
            this.RibbonComboBoxScale.Items.Add(this.AdxRibbonItem3);
            this.RibbonComboBoxScale.Items.Add(this.AdxRibbonItem4);
            this.RibbonComboBoxScale.Items.Add(this.AdxRibbonItem5);
            this.RibbonComboBoxScale.Items.Add(this.AdxRibbonItem6);
            this.RibbonComboBoxScale.Items.Add(this.AdxRibbonItem7);
            this.RibbonComboBoxScale.Items.Add(this.AdxRibbonItem8);
            this.RibbonComboBoxScale.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            this.RibbonComboBoxScale.SizeString = "WWWWWWWWWWWs";
            this.RibbonComboBoxScale.OnChange += new AddinExpress.MSO.ADXRibbonOnActionChange_EventHandler(this.RibbonComboBoxScale_OnChange);
            // 
            // AdxRibbonItem1
            // 
            this.AdxRibbonItem1.Caption = "200%";
            this.AdxRibbonItem1.Id = "adxRibbonItem_564d0cb34d6a42d2a6f20a14be331ef3";
            this.AdxRibbonItem1.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem2
            // 
            this.AdxRibbonItem2.Caption = "150%";
            this.AdxRibbonItem2.Id = "adxRibbonItem_20a3db7b95bb413389bb3e9e22e93566";
            this.AdxRibbonItem2.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem3
            // 
            this.AdxRibbonItem3.Caption = "100%";
            this.AdxRibbonItem3.Id = "adxRibbonItem_047012263e5541e8a6ab9d7283347759";
            this.AdxRibbonItem3.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem4
            // 
            this.AdxRibbonItem4.Caption = "90%";
            this.AdxRibbonItem4.Id = "adxRibbonItem_d1cda057140a4d74b17cfa73e46f0b3a";
            this.AdxRibbonItem4.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem5
            // 
            this.AdxRibbonItem5.Caption = "80%";
            this.AdxRibbonItem5.Id = "adxRibbonItem_75cc5a4be5664e269e3371080b3bd680";
            this.AdxRibbonItem5.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem6
            // 
            this.AdxRibbonItem6.Caption = "66%";
            this.AdxRibbonItem6.Id = "adxRibbonItem_0f60c32356ef4f5d9bd69121dbc2ef49";
            this.AdxRibbonItem6.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem7
            // 
            this.AdxRibbonItem7.Caption = "50%";
            this.AdxRibbonItem7.Id = "adxRibbonItem_47492540edd64df4a3f7194e05a22ba9";
            this.AdxRibbonItem7.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem8
            // 
            this.AdxRibbonItem8.Caption = "33%";
            this.AdxRibbonItem8.Id = "adxRibbonItem_10e2ae75bad748a99754f60210ea1377";
            this.AdxRibbonItem8.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // RibbonBoxSpace
            // 
            this.RibbonBoxSpace.Controls.Add(this.RibbonComboBoxSpace);
            this.RibbonBoxSpace.Controls.Add(this.RibbonEditBoxSpace);
            this.RibbonBoxSpace.Id = "adxRibbonBox_3388bbc50801461ebacd815d1f80d9ca";
            this.RibbonBoxSpace.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // RibbonComboBoxSpace
            // 
            this.RibbonComboBoxSpace.Caption = "Space";
            this.RibbonComboBoxSpace.Id = "adxRibbonComboBox_143f93c813894d1d8fec7a3003670530";
            this.RibbonComboBoxSpace.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonComboBoxSpace.Items.Add(this.AdxRibbonItem9);
            this.RibbonComboBoxSpace.Items.Add(this.AdxRibbonItem10);
            this.RibbonComboBoxSpace.Items.Add(this.AdxRibbonItem11);
            this.RibbonComboBoxSpace.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            this.RibbonComboBoxSpace.SizeString = "WWWWWWWWWWaa";
            this.RibbonComboBoxSpace.OnChange += new AddinExpress.MSO.ADXRibbonOnActionChange_EventHandler(this.RibbonComboBoxSpace_OnChange);
            // 
            // AdxRibbonItem9
            // 
            this.AdxRibbonItem9.Caption = "Normal";
            this.AdxRibbonItem9.Id = "adxRibbonItem_e9a6a6315b234e1ca4916c1f9aa31f24";
            this.AdxRibbonItem9.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem10
            // 
            this.AdxRibbonItem10.Caption = "Expanded";
            this.AdxRibbonItem10.Id = "adxRibbonItem_c8a92c3b83f64b7c90ceda46d40d4a68";
            this.AdxRibbonItem10.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem11
            // 
            this.AdxRibbonItem11.Caption = "Condensed";
            this.AdxRibbonItem11.Id = "adxRibbonItem_cd8faca9ece74735a14defa9b46bc2bd";
            this.AdxRibbonItem11.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // RibbonEditBoxSpace
            // 
            this.RibbonEditBoxSpace.Caption = "By";
            this.RibbonEditBoxSpace.Id = "adxRibbonEditBox_0f6451e59bf644c5aaeec019a1c810ec";
            this.RibbonEditBoxSpace.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonEditBoxSpace.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            this.RibbonEditBoxSpace.OnChange += new AddinExpress.MSO.ADXRibbonOnActionChange_EventHandler(this.RibbonEditBoxSpace_OnChange);
            // 
            // RibbonBoxPosition
            // 
            this.RibbonBoxPosition.Controls.Add(this.RibbonComboBoxPosition);
            this.RibbonBoxPosition.Controls.Add(this.RibbonEditBoxPosition);
            this.RibbonBoxPosition.Id = "adxRibbonBox_0a85d0f92f20480693610f35acc989c3";
            this.RibbonBoxPosition.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // RibbonComboBoxPosition
            // 
            this.RibbonComboBoxPosition.Caption = "Position";
            this.RibbonComboBoxPosition.Id = "adxRibbonComboBox_6c6a957e71324ca38e7ad600b4583203";
            this.RibbonComboBoxPosition.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonComboBoxPosition.Items.Add(this.AdxRibbonItem12);
            this.RibbonComboBoxPosition.Items.Add(this.AdxRibbonItem13);
            this.RibbonComboBoxPosition.Items.Add(this.AdxRibbonItem14);
            this.RibbonComboBoxPosition.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            this.RibbonComboBoxPosition.SizeString = "WWWWWWWWWW";
            this.RibbonComboBoxPosition.OnChange += new AddinExpress.MSO.ADXRibbonOnActionChange_EventHandler(this.RibbonComboBoxPosition_OnChange);
            // 
            // AdxRibbonItem12
            // 
            this.AdxRibbonItem12.Caption = "Normal";
            this.AdxRibbonItem12.Id = "adxRibbonItem_4a2556515af540c9a6d214249e1fb966";
            this.AdxRibbonItem12.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem13
            // 
            this.AdxRibbonItem13.Caption = "Raised";
            this.AdxRibbonItem13.Id = "adxRibbonItem_5f862943f23a4f4a8f4fc954f2bd6fb1";
            this.AdxRibbonItem13.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem14
            // 
            this.AdxRibbonItem14.Caption = "Lowered";
            this.AdxRibbonItem14.Id = "adxRibbonItem_064fc2a0ad5b414cb0366a1e578e6fb0";
            this.AdxRibbonItem14.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // RibbonEditBoxPosition
            // 
            this.RibbonEditBoxPosition.Caption = "By";
            this.RibbonEditBoxPosition.Id = "adxRibbonEditBox_ee1108d9a7c9427badb11d72bd26ae4b";
            this.RibbonEditBoxPosition.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonEditBoxPosition.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            this.RibbonEditBoxPosition.OnChange += new AddinExpress.MSO.ADXRibbonOnActionChange_EventHandler(this.RibbonEditBoxPosition_OnChange);
            // 
            // AdxRibbonSeparator2
            // 
            this.AdxRibbonSeparator2.Id = "adxRibbonSeparator_9185694ac97044c8aa80bddbe78fb3ef";
            this.AdxRibbonSeparator2.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            // 
            // RibbonComboBoxEffects
            // 
            this.RibbonComboBoxEffects.Caption = "Effects";
            this.RibbonComboBoxEffects.Id = "adxRibbonComboBox_d6b99d99d8a043d1ba27c3f17f85b69f";
            this.RibbonComboBoxEffects.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.RibbonComboBoxEffects.Items.Add(this.AdxRibbonItem15);
            this.RibbonComboBoxEffects.Items.Add(this.AdxRibbonItem16);
            this.RibbonComboBoxEffects.Items.Add(this.AdxRibbonItem17);
            this.RibbonComboBoxEffects.Items.Add(this.AdxRibbonItem18);
            this.RibbonComboBoxEffects.Items.Add(this.AdxRibbonItem19);
            this.RibbonComboBoxEffects.Items.Add(this.AdxRibbonItem20);
            this.RibbonComboBoxEffects.Items.Add(this.AdxRibbonItem21);
            this.RibbonComboBoxEffects.Ribbons = AddinExpress.MSO.ADXRibbons.msrWordDocument;
            this.RibbonComboBoxEffects.SizeString = "WWWWWWWWWWW";
            this.RibbonComboBoxEffects.OnChange += new AddinExpress.MSO.ADXRibbonOnActionChange_EventHandler(this.RibbonComboBoxEffects_OnChange);
            // 
            // AdxRibbonItem15
            // 
            this.AdxRibbonItem15.Caption = "(none)";
            this.AdxRibbonItem15.Id = "adxRibbonItem_0be9e99f736847178396a8bdd92d5b54";
            this.AdxRibbonItem15.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem16
            // 
            this.AdxRibbonItem16.Caption = "Blinking Background";
            this.AdxRibbonItem16.Id = "adxRibbonItem_0be9e99f736847178396a8bdd92d5b55";
            this.AdxRibbonItem16.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem17
            // 
            this.AdxRibbonItem17.Caption = "Las Vegas Lights";
            this.AdxRibbonItem17.Id = "adxRibbonItem_0be9e99f736847178396a8bdd92d5b56";
            this.AdxRibbonItem17.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem18
            // 
            this.AdxRibbonItem18.Caption = "Marching Black Ants";
            this.AdxRibbonItem18.Id = "adxRibbonItem_0be9e99f736847178396a8bdd92d5b57";
            this.AdxRibbonItem18.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem19
            // 
            this.AdxRibbonItem19.Caption = "Marching Red Ants";
            this.AdxRibbonItem19.Id = "adxRibbonItem_0be9e99f736847178396a8bdd92d5b58";
            this.AdxRibbonItem19.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem20
            // 
            this.AdxRibbonItem20.Caption = "Shimmer";
            this.AdxRibbonItem20.Id = "adxRibbonItem_0be9e99f736847178396a8bdd92d5b59";
            this.AdxRibbonItem20.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AdxRibbonItem21
            // 
            this.AdxRibbonItem21.Caption = "Sparkle Text";
            this.AdxRibbonItem21.Id = "adxRibbonItem_0be9e99f736847178396a8bdd92d5b50";
            this.AdxRibbonItem21.ImageTransparentColor = System.Drawing.Color.Transparent;
            // 
            // AddinModule
            // 
            this.AddinName = "Add-in Express Toys for Word (C#)";
            this.Description = "Add-in Express Toys for Word (C#)";
            this.Images = this.imageList1;
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaWord;
            this.AddinInitialize += new AddinExpress.MSO.ADXEvents_EventHandler(this.WToysConnect_AddinInitialize);
            this.OnError += new AddinExpress.MSO.ADXError_EventHandler(this.WToysConnect_OnError);

        }
        #endregion

        #region Add-in Module Implementation

        /// <summary>
        /// Required method for ADX support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        public override System.ComponentModel.IContainer GetContainer()
        {
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public AddinModule(System.ComponentModel.IContainer container)
        {
            container.Add(this);
            InitializeComponent();
        }

        public AddinModule()
        {
            InitializeComponent();
        }

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Word._Application WordApp
        {
            get
            {
                return (HostApplication as Word._Application);
            }
        }

        private void WToysConnect_AddinInitialize(object sender, System.EventArgs e)
        {
            if (StartMode == AddinExpress.MSO.ADXStartMode.smFirstStart)
            {
                adxCommandBar1.Position = AddinExpress.MSO.ADXMsoBarPosition.adxMsoBarFloating;
                DoAbout();
            }
        }

        private void WToysConnect_OnError(AddinExpress.MSO.ADXErrorEventArgs e)
        {
            e.Handled = true;
            MessageBox.Show(e.ADXError.Message, e.ADXError.Message, MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

        private void btnAbout_Click(object sender)
        {
            DoAbout();
        }

        private void RibbonButtonAbout_OnClick(object sender, AddinExpress.MSO.IRibbonControl control, bool pressed)
        {
            DoAbout();
        }

        private void DoAbout()
        {
            string toysVersion = Assembly.GetExecutingAssembly().GetName().Version.ToString(4);
            string adxVersion = Assembly.GetAssembly(typeof(AddinExpress.MSO.ADXAddinModule)).GetName().Version.ToString(3);
            AboutForm about = new AboutForm();
            about.LabelFor.Text = String.Format(about.LabelFor.Text, new Object[] { "Microsoft" + Convert.ToChar(174) + " Word" });
            about.LabelVersion.Text = String.Format(about.LabelVersion.Text, new Object[] { toysVersion });
            about.LabelADXVersion.Text = String.Format(about.LabelADXVersion.Text, new Object[] { adxVersion });
            about.ShowDialog();
            about.Dispose();
        }

        private void cmbScale_Change(object sender)
        {
            int scale = Convert.ToInt32(cmbScale.Text.Trim().Replace("%", ""));
            DoScale(scale);
        }

        private void RibbonComboBoxScale_OnChange(object sender, AddinExpress.MSO.IRibbonControl Control, string text)
        {
            int scale = Convert.ToInt32(text.Trim().Replace("%", ""));
            DoScale(scale);
        }

        private void DoScale(int scale)
        {
            Word.Window activeWindow = WordApp.ActiveWindow;
            if (activeWindow != null)
            {
                if (scale <= 600 && scale > 0)
                {
                    Word.Selection selObj = activeWindow.Selection as Word.Selection;
                    if (selObj != null)
                    {
                        selObj.Font.Scaling = scale;
                        DoSelectionChange(selObj);
                        Marshal.ReleaseComObject(selObj);
                    }
                }
                else
                    DoWindowActivate(activeWindow);
                Marshal.ReleaseComObject(activeWindow);
            }
        }

        internal void DoDocumentChange()
        {
            Word.Selection selection = null;
            try
            {
                selection = WordApp.Selection;
                DoSelectionChange(selection);
            }
            finally
            {
                if (selection != null)
                    Marshal.ReleaseComObject(selection);
            }
        }

        internal void DoWindowActivate(Word.Window wn)
        {
            Word.Selection sel = wn.Selection;
            try
            {
                DoSelectionChange(sel);
            }
            finally { Marshal.ReleaseComObject(sel); }
        }

        internal void DoSelectionChange(Word.Selection selection)
        {
            if (selection == null) return;
            
            int currentScale = selection.Font.Scaling;
            if (currentScale == 9999999)
            {
                cmbScale.Text = "";
                RibbonComboBoxScale.Text = cmbScale.Text;
            }
            else
            {
                cmbScale.Text = currentScale.ToString() + "%";
                RibbonComboBoxScale.Text = cmbScale.Text;
            }

            Word.WdAnimation currentAnimation = selection.Font.Animation;
            if ((int)currentAnimation == 9999999)
            {
                cmbEffects.Text = "";
                RibbonComboBoxEffects.Text = cmbEffects.Text;
            }
            else
            {
                switch (currentAnimation)
                {
                    case Word.WdAnimation.wdAnimationNone:
                        cmbEffects.Text = "(none)";
                        break;
                    case Word.WdAnimation.wdAnimationBlinkingBackground:
                        cmbEffects.Text = "Blinking Background";
                        break;
                    case Word.WdAnimation.wdAnimationLasVegasLights:
                        cmbEffects.Text = "Las Vegas Lights";
                        break;
                    case Word.WdAnimation.wdAnimationMarchingBlackAnts:
                        cmbEffects.Text = "Marching Black Ants";
                        break;
                    case Word.WdAnimation.wdAnimationMarchingRedAnts:
                        cmbEffects.Text = "Marching Red Ants";
                        break;
                    case Word.WdAnimation.wdAnimationShimmer:
                        cmbEffects.Text = "Shimmer";
                        break;
                    case Word.WdAnimation.wdAnimationSparkleText:
                        cmbEffects.Text = "Sparkle Text";
                        break;
                }
                RibbonComboBoxEffects.Text = cmbEffects.Text;
            }

            float currentSpace = selection.Font.Spacing;
            if (currentSpace == 9999999)
            {
                cmbSpace.Text = "";
                edSpace.Text = "";
                RibbonComboBoxSpace.Text = cmbSpace.Text;
                RibbonEditBoxSpace.Text = edSpace.Text;
            }
            else
            {
                edSpace.Text = currentSpace.ToString();
                if (currentSpace == 0)
                {
                    cmbSpace.ListIndex = 1;
                    edSpace.Text = "";
                    RibbonComboBoxSpace.Text = "Normal";
                    RibbonEditBoxSpace.Text = edSpace.Text;
                }
                else if (currentSpace > 0)
                {
                    cmbSpace.ListIndex = 2;
                    edSpace.Text = currentSpace.ToString();
                    RibbonComboBoxSpace.Text = "Expanded";
                    RibbonEditBoxSpace.Text = edSpace.Text;
                }
                else if (currentSpace < 0)
                {
                    cmbSpace.ListIndex = 3;
                    edSpace.Text = (currentSpace * (-1)).ToString();
                    RibbonComboBoxSpace.Text = "Condensed";
                    RibbonEditBoxSpace.Text = edSpace.Text;
                }
            }

            int currentPosition = selection.Font.Position;
            if (currentPosition == 9999999)
            {
                cmbPosition.Text = "";
                edPosition.Text = "";
                RibbonComboBoxPosition.Text = cmbPosition.Text;
                RibbonEditBoxPosition.Text = edPosition.Text;
            }
            else
            {
                edPosition.Text = currentPosition.ToString();
                if (currentPosition == 0)
                {
                    cmbPosition.ListIndex = 1;
                    edPosition.Text = "";
                    RibbonComboBoxPosition.Text = "Normal";
                    RibbonEditBoxPosition.Text = edPosition.Text;
                }
                else if (currentPosition > 0)
                {
                    cmbPosition.ListIndex = 2;
                    edPosition.Text = currentPosition.ToString();
                    RibbonComboBoxPosition.Text = "Raised";
                    RibbonEditBoxPosition.Text = edPosition.Text;
                }
                else if (currentPosition < 0)
                {
                    cmbPosition.ListIndex = 3;
                    edPosition.Text = (currentPosition * (-1)).ToString();
                    RibbonComboBoxPosition.Text = "Lowered";
                    RibbonEditBoxPosition.Text = edPosition.Text;
                }
            }
        }

        private void cmbEffects_Change(object sender)
        {
            string effect = cmbEffects.Text.Trim();
            DoEffects(effect);
        }

        private void RibbonComboBoxEffects_OnChange(object sender, AddinExpress.MSO.IRibbonControl Control, string text)
        {
            string effect = text.Trim();
            DoEffects(effect);
        }

        private void DoEffects(string effect)
        {
            Word.Window activeWindow = WordApp.ActiveWindow;
            if (activeWindow != null)
            {
                Word.Selection selObj = activeWindow.Selection;
                if (selObj != null)
                {
                    switch (effect)
                    {
                        case "(none)":
                            selObj.Font.Animation = Word.WdAnimation.wdAnimationNone;
                            break;
                        case "Blinking Background":
                            selObj.Font.Animation = Word.WdAnimation.wdAnimationBlinkingBackground;
                            break;
                        case "Las Vegas Lights":
                            selObj.Font.Animation = Word.WdAnimation.wdAnimationLasVegasLights;
                            break;
                        case "Marching Black Ants":
                            selObj.Font.Animation = Word.WdAnimation.wdAnimationMarchingBlackAnts;
                            break;
                        case "Marching Red Ants":
                            selObj.Font.Animation = Word.WdAnimation.wdAnimationMarchingRedAnts;
                            break;
                        case "Shimmer":
                            selObj.Font.Animation = Word.WdAnimation.wdAnimationShimmer;
                            break;
                        case "Sparkle Text":
                            selObj.Font.Animation = Word.WdAnimation.wdAnimationSparkleText;
                            break;
                        default:
                            DoWindowActivate(activeWindow);
                            break;
                    }
                    Marshal.ReleaseComObject(selObj);
                }
                Marshal.ReleaseComObject(activeWindow);
            }
        }

        private void cmbSpace_Change(object sender)
        {
            Word.Window activeWindow = WordApp.ActiveWindow;
            if (activeWindow != null)
            {
                Word.Selection selObj = activeWindow.Selection;
                if (selObj != null)
                {
                    switch (cmbSpace.ListIndex)
                    {
                        case 1:
                            selObj.Font.Spacing = 0;
                            edSpace.Text = "";
                            break;
                        case 2:
                            selObj.Font.Spacing = 1;
                            edSpace.Text = "1";
                            break;
                        case 3:
                            selObj.Font.Spacing = -1;
                            edSpace.Text = "1";
                            break;
                        default:
                            DoWindowActivate(activeWindow);
                            break;
                    }
                    Marshal.ReleaseComObject(selObj);
                }
                Marshal.ReleaseComObject(activeWindow);
            }
        }

        private void RibbonComboBoxSpace_OnChange(object sender, AddinExpress.MSO.IRibbonControl Control, string text)
        {
            Word.Window activeWindow = WordApp.ActiveWindow;
            if (activeWindow != null)
            {
                Word.Selection selObj = activeWindow.Selection;
                if (selObj != null)
                {
                    switch (text)
                    {
                        case "Normal":
                            selObj.Font.Spacing = 0;
                            RibbonEditBoxSpace.Text = "";
                            break;
                        case "Expanded":
                            selObj.Font.Spacing = 1;
                            RibbonEditBoxSpace.Text = "1";
                            break;
                        case "Condensed":
                            selObj.Font.Spacing = -1;
                            RibbonEditBoxSpace.Text = "1";
                            break;
                        default:
                            DoWindowActivate(activeWindow);
                            break;
                    }
                    Marshal.ReleaseComObject(selObj);
                }
                Marshal.ReleaseComObject(activeWindow);
            }
        }

        private void edSpace_Change(object sender)
        {
            float space = 0;
            if (edSpace.Text.Trim() != string.Empty)
                space = (float)Convert.ToDouble(edSpace.Text.Trim());
            Word.Window activeWindow = WordApp.ActiveWindow;
            if (activeWindow != null)
            {
                if (space >= 0 && space <= 1584)
                {
                    Word.Selection selObj = activeWindow.Selection;
                    if (selObj != null)
                    {
                        if (space == 0)
                        {
                            selObj.Font.Spacing = space;
                            edSpace.Text = "";
                            cmbSpace.ListIndex = 1;
                        }
                        else
                            switch (cmbSpace.ListIndex)
                            {
                                case 2:
                                    selObj.Font.Spacing = space;
                                    edSpace.Text = space.ToString();
                                    break;
                                case 3:
                                    selObj.Font.Spacing = (space * (-1));
                                    edSpace.Text = space.ToString(); ;
                                    break;
                                default:
                                    DoWindowActivate(activeWindow);
                                    break;
                            }
                    }
                }
                else
                    DoWindowActivate(activeWindow);
                Marshal.ReleaseComObject(activeWindow);
            }
        }

        private void RibbonEditBoxSpace_OnChange(object sender, AddinExpress.MSO.IRibbonControl Control, string text)
        {
            float space = 0;
            if (text.Trim() != string.Empty)
                space = (float)Convert.ToDouble(text.Trim());
            Word.Window activeWindow = WordApp.ActiveWindow;
            if (activeWindow != null)
            {
                if (space >= 0 && space <= 1584)
                {
                    Word.Selection selObj = activeWindow.Selection;
                    if (selObj != null)
                    {
                        if (space == 0)
                        {
                            selObj.Font.Spacing = space;
                            RibbonEditBoxSpace.Text = "";
                            RibbonComboBoxSpace.Text = "Normal";
                        }
                        else
                            switch (RibbonComboBoxSpace.Text)
                            {
                                case "Expanded":
                                    selObj.Font.Spacing = space;
                                    RibbonEditBoxSpace.Text = space.ToString();
                                    break;
                                case "Condensed":
                                    selObj.Font.Spacing = (space * (-1));
                                    RibbonEditBoxSpace.Text = space.ToString(); ;
                                    break;
                                default:
                                    DoWindowActivate(activeWindow);
                                    break;
                            }
                    }
                }
                else
                    DoWindowActivate(activeWindow);
                Marshal.ReleaseComObject(activeWindow);
            }
        }

        private void cmbPosition_Change(object sender)
        {
            Word.Window activeWindow = WordApp.ActiveWindow;
            if (activeWindow != null)
            {
                Word.Selection selObj = activeWindow.Selection;
                if (selObj != null)
                {
                    switch (cmbPosition.ListIndex)
                    {
                        case 1:
                            selObj.Font.Position = 0;
                            edPosition.Text = "";
                            break;
                        case 2:
                            selObj.Font.Position = 3;
                            edPosition.Text = "3";
                            break;
                        case 3:
                            selObj.Font.Position = -3;
                            edPosition.Text = "3";
                            break;
                        default:
                            DoWindowActivate(activeWindow);
                            break;
                    }
                    Marshal.ReleaseComObject(selObj);
                }
                Marshal.ReleaseComObject(activeWindow);
            }
        }

        private void RibbonComboBoxPosition_OnChange(object sender, AddinExpress.MSO.IRibbonControl Control, string text)
        {
            Word.Window activeWindow = WordApp.ActiveWindow;
            if (activeWindow != null)
            {
                Word.Selection selObj = activeWindow.Selection;
                if (selObj != null)
                {
                    switch (text)
                    {
                        case "Normal":
                            selObj.Font.Position = 0;
                            RibbonEditBoxPosition.Text = "";
                            break;
                        case "Raised":
                            selObj.Font.Position = 3;
                            RibbonEditBoxPosition.Text = "3";
                            break;
                        case "Lowered":
                            selObj.Font.Position = -3;
                            RibbonEditBoxPosition.Text = "3";
                            break;
                        default:
                            DoWindowActivate(activeWindow);
                            break;
                    }
                    Marshal.ReleaseComObject(selObj);
                }
                Marshal.ReleaseComObject(activeWindow);
            }
        }

        private void edPosition_Change(object sender)
        {
            int position = 0;
            if (edPosition.Text.Trim() != String.Empty)
                position = Convert.ToInt32(edPosition.Text.Trim());
            Word.Window activeWindow = WordApp.ActiveWindow;
            if (activeWindow != null)
            {
                if (position >= 0 && position <= 1584)
                {
                    Word.Selection selObj = activeWindow.Selection;
                    if (selObj != null)
                    {
                        if (position == 0)
                        {
                            selObj.Font.Position = position;
                            edPosition.Text = "";
                            cmbPosition.ListIndex = 1;
                        }
                        else
                            switch (cmbPosition.ListIndex)
                            {
                                case 2:
                                    selObj.Font.Position = position;
                                    edPosition.Text = position.ToString();
                                    break;
                                case 3:
                                    selObj.Font.Position = (position * (-1));
                                    edPosition.Text = position.ToString();
                                    break;
                                default:
                                    DoWindowActivate(activeWindow);
                                    break;
                            }
                        Marshal.ReleaseComObject(selObj);
                    }
                }
                else
                    DoWindowActivate(activeWindow);
                Marshal.ReleaseComObject(activeWindow);
            }
        }

        private void RibbonEditBoxPosition_OnChange(object sender, AddinExpress.MSO.IRibbonControl Control, string text)
        {
            int position = 0;
            if (text.Trim() != String.Empty)
                position = Convert.ToInt32(text.Trim());
            Word.Window activeWindow = WordApp.ActiveWindow;
            if (activeWindow != null)
            {
                if (position >= 0 && position <= 1584)
                {
                    Word.Selection selObj = activeWindow.Selection;
                    if (selObj != null)
                    {
                        if (position == 0)
                        {
                            selObj.Font.Position = position;
                            RibbonEditBoxPosition.Text = "";
                            RibbonComboBoxPosition.Text = "Normal";
                        }
                        else
                            switch (RibbonComboBoxPosition.Text)
                            {
                                case "Raised":
                                    selObj.Font.Position = position;
                                    RibbonEditBoxPosition.Text = position.ToString();
                                    break;
                                case "Lowered":
                                    selObj.Font.Position = (position * (-1));
                                    RibbonEditBoxPosition.Text = position.ToString();
                                    break;
                                default:
                                    DoWindowActivate(activeWindow);
                                    break;
                            }
                        Marshal.ReleaseComObject(selObj);
                    }
                }
                else
                    DoWindowActivate(activeWindow);
                Marshal.ReleaseComObject(activeWindow);
            }
        }

        private void adxWordEvents_DocumentChange(object sender, System.EventArgs e)
        {
            DoDocumentChange();
        }

        private void adxWordEvents_WindowActivate(object sender, object hostObj, object window)
        {
            DoWindowActivate(window as Word.Window);
        }

        private void adxWordEvents_WindowSelectionChange(object sender, object hostObj)
        {
            DoSelectionChange(hostObj as Word.Selection);
        }

    }
}

